﻿Imports Microsoft.VisualBasic

Namespace DLAFormfactory
    ''' <summary>
    ''' class based on a combination name - value - type
    ''' is used to make data from controls transportable through layers
    ''' </summary>
    ''' <remarks></remarks>
    Public Class DLAParameter
        Private strName As String
        Private strValue As String
        Private strType As String
        Private blnIsNull As Boolean
        ''' <summary>
        ''' Initialization of the class
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub New()
            strName = ""
            strValue = ""
            strType = ""
            blnIsNull = True
        End Sub
        ''' <summary>
        ''' constructor which immediately stores the values ​​in the variables
        ''' note that everything is of type string
        ''' addition null value set
        ''' </summary>
        ''' <param name="strN"></param>
        ''' <param name="strV"></param>
        ''' <param name="strT"></param>
        ''' <param name="blnN"></param>
        ''' <remarks></remarks>
        Public Sub New(ByVal strN As String, ByVal strV As String, ByVal strT As String, ByVal blnN As Boolean)
            strName = strN.ToLower()
            Me.SetValue(strV)
            strType = strT.ToUpper()
            blnIsNull = blnN
        End Sub
        ''' <summary>
        ''' constructor which immediately stores the values ​​in the variables
        ''' note that everything is of type string
        ''' </summary>
        ''' <param name="strN"></param>
        ''' <param name="strV"></param>
        ''' <param name="strT"></param>
        ''' <remarks></remarks>
        Public Sub New(ByVal strN As String, ByVal strV As String, ByVal strT As String)
            strName = strN.ToLower()
            Me.SetValue(strV)
            strType = strT.ToUpper()
        End Sub
        ''' <summary>
        ''' Get the value again
        ''' here a conversion can also take place, for example date values
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetValue() As String
            Return Me.strValue
        End Function
        ''' <summary>
        ''' get the value again
        ''' here the conversion takes place of, for example, date values
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetSqlValue() As String
            Dim blnFound As Boolean
            blnFound = False

            'als het een currency waarde is
            If strValue.IndexOf("€") >= 0 Then
                'strValue = strValue.Replace(",", ".")
                strValue = strValue.Replace("€", "")
            End If
            ' als het een boolean waarde is converteren naar int
            If Me.strValue.ToLower = "false" Then
                strValue = "0"
            End If
            If Me.strValue.ToLower = "true" Then
                strValue = "-1"
            End If
            Dim dDatum As Date
            If Date.TryParse(strValue, dDatum) Then
                strValue = dDatum.ToString("yyyy-MM-dd")
            End If
            strValue = strValue.Replace(Chr(34), "'")
            blnFound = True
            'End If
            Return Me.strValue
        End Function
        ''' <summary>
        ''' Set the values ​​as length 0 then NULL as string
        ''' </summary>
        ''' <param name="strV"></param>
        ''' <remarks></remarks>
        Public Sub SetValue(ByVal strV As String)
            strV = Trim(strV)
            If strV.Length = 0 Then
                strValue = "NULL"
            Else
                Me.strValue = strV
            End If
        End Sub
        ''' <summary>
        ''' Return the name of the parameter
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetName() As String
            Return Me.strName
        End Function
        ''' <summary>
        '''Get the name as a DLA SQL identifier
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetIdentifier() As String
            Return "#" & Me.strName & "#"
        End Function
    End Class
End Namespace
